/* Job.c generated by valac 0.38.10, the Vala compiler
 * generated from Job.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2015 Pantheon Developers (https://launchpad.net/switchboard-plug-printers)
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 3 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street - Fifth Floor,
 * Boston, MA 02110-1301, USA.
 *
 * Authored by: Corentin Noël <corentin@elementary.io>
 */

#include <glib.h>
#include <glib-object.h>
#include "cups/cups.h"
#include "cups/ipp.h"
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>
#include <time.h>
#include <glib/gi18n-lib.h>


#define PRINTERS_TYPE_JOB (printers_job_get_type ())
#define PRINTERS_JOB(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), PRINTERS_TYPE_JOB, PrintersJob))
#define PRINTERS_JOB_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), PRINTERS_TYPE_JOB, PrintersJobClass))
#define PRINTERS_IS_JOB(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), PRINTERS_TYPE_JOB))
#define PRINTERS_IS_JOB_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), PRINTERS_TYPE_JOB))
#define PRINTERS_JOB_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), PRINTERS_TYPE_JOB, PrintersJobClass))

typedef struct _PrintersJob PrintersJob;
typedef struct _PrintersJobClass PrintersJobClass;
typedef struct _PrintersJobPrivate PrintersJobPrivate;

#define PRINTERS_TYPE_PRINTER (printers_printer_get_type ())
#define PRINTERS_PRINTER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), PRINTERS_TYPE_PRINTER, PrintersPrinter))
#define PRINTERS_PRINTER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), PRINTERS_TYPE_PRINTER, PrintersPrinterClass))
#define PRINTERS_IS_PRINTER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), PRINTERS_TYPE_PRINTER))
#define PRINTERS_IS_PRINTER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), PRINTERS_TYPE_PRINTER))
#define PRINTERS_PRINTER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), PRINTERS_TYPE_PRINTER, PrintersPrinterClass))

typedef struct _PrintersPrinter PrintersPrinter;
typedef struct _PrintersPrinterClass PrintersPrinterClass;
enum  {
	PRINTERS_JOB_0_PROPERTY,
	PRINTERS_JOB_NUM_PROPERTIES
};
static GParamSpec* printers_job_properties[PRINTERS_JOB_NUM_PROPERTIES];

#define CUPS_TYPE_NOTIFIER (cups_notifier_get_type ())
#define CUPS_NOTIFIER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), CUPS_TYPE_NOTIFIER, CupsNotifier))
#define CUPS_NOTIFIER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), CUPS_TYPE_NOTIFIER, CupsNotifierClass))
#define CUPS_IS_NOTIFIER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), CUPS_TYPE_NOTIFIER))
#define CUPS_IS_NOTIFIER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), CUPS_TYPE_NOTIFIER))
#define CUPS_NOTIFIER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), CUPS_TYPE_NOTIFIER, CupsNotifierClass))

typedef struct _CupsNotifier CupsNotifier;
typedef struct _CupsNotifierClass CupsNotifierClass;

#define CUPS_TYPE_PK_HELPER (cups_pk_helper_get_type ())
#define CUPS_PK_HELPER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), CUPS_TYPE_PK_HELPER, CupsPkHelper))
#define CUPS_IS_PK_HELPER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), CUPS_TYPE_PK_HELPER))
#define CUPS_PK_HELPER_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), CUPS_TYPE_PK_HELPER, CupsPkHelperIface))

typedef struct _CupsPkHelper CupsPkHelper;
typedef struct _CupsPkHelperIface CupsPkHelperIface;

#define CUPS_TYPE_PK_HELPER_PROXY (cups_pk_helper_proxy_get_type ())
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))
#define _ippDelete0(var) ((var == NULL) ? NULL : (var = (ippDelete (var), NULL)))
enum  {
	PRINTERS_JOB_STOPPED_SIGNAL,
	PRINTERS_JOB_COMPLETED_SIGNAL,
	PRINTERS_JOB_STATE_CHANGED_SIGNAL,
	PRINTERS_JOB_NUM_SIGNALS
};
static guint printers_job_signals[PRINTERS_JOB_NUM_SIGNALS] = {0};

struct _PrintersJob {
	GObject parent_instance;
	PrintersJobPrivate * priv;
	cups_job_t cjob;
};

struct _PrintersJobClass {
	GObjectClass parent_class;
};

struct _PrintersJobPrivate {
	PrintersPrinter* printer;
	gint uid;
};

struct _CupsPkHelperIface {
	GTypeInterface parent_iface;
	gchar* (*file_get) (CupsPkHelper* self, const gchar* resource, const gchar* filename, GError** error);
	gchar* (*file_put) (CupsPkHelper* self, const gchar* resource, const gchar* filename, GError** error);
	void (*server_get_settings) (CupsPkHelper* self, gchar* * _error_, GHashTable* * settings, GError** error);
	gchar* (*server_set_settings) (CupsPkHelper* self, GHashTable* settings, GError** error);
	void (*devices_get) (CupsPkHelper* self, gint timeout, gint limit, gchar** include_schemes, int include_schemes_length1, gchar** exclude_schemes, int exclude_schemes_length1, GAsyncReadyCallback _callback_, gpointer _user_data_);
	void (*devices_get_finish) (CupsPkHelper* self, GAsyncResult* _res_, gchar* * _error_, GHashTable* * devices, GError** error);
	gchar* (*printer_add) (CupsPkHelper* self, const gchar* name, const gchar* uri, const gchar* ppd, const gchar* info, const gchar* location, GError** error);
	gchar* (*printer_add_with_ppd_file) (CupsPkHelper* self, const gchar* name, const gchar* uri, const gchar* ppd, const gchar* info, const gchar* location, GError** error);
	gchar* (*printer_set_device) (CupsPkHelper* self, const gchar* name, const gchar* device, GError** error);
	gchar* (*printer_set_default) (CupsPkHelper* self, const gchar* name, GError** error);
	gchar* (*printer_set_enabled) (CupsPkHelper* self, const gchar* name, gboolean enabled, GError** error);
	gchar* (*printer_set_accept_jobs) (CupsPkHelper* self, const gchar* name, gboolean enabled, const gchar* reason, GError** error);
	gchar* (*printer_delete) (CupsPkHelper* self, const gchar* name, GError** error);
	gchar* (*class_add_printer) (CupsPkHelper* self, const gchar* name, const gchar* printer, GError** error);
	gchar* (*class_delete_printer) (CupsPkHelper* self, const gchar* name, const gchar* printer, GError** error);
	gchar* (*class_delete) (CupsPkHelper* self, const gchar* name, GError** error);
	gchar* (*printer_set_info) (CupsPkHelper* self, const gchar* name, const gchar* info, GError** error);
	gchar* (*printer_set_location) (CupsPkHelper* self, const gchar* name, const gchar* location, GError** error);
	gchar* (*printer_set_shared) (CupsPkHelper* self, const gchar* name, gboolean shared, GError** error);
	gchar* (*printer_set_job_sheets) (CupsPkHelper* self, const gchar* name, const gchar* start, const gchar* end, GError** error);
	gchar* (*printer_set_error_policy) (CupsPkHelper* self, const gchar* name, const gchar* policy, GError** error);
	gchar* (*printer_set_op_policy) (CupsPkHelper* self, const gchar* name, const gchar* policy, GError** error);
	gchar* (*printer_set_users_allowed) (CupsPkHelper* self, const gchar* name, gchar** users, int users_length1, GError** error);
	gchar* (*printer_set_users_denied) (CupsPkHelper* self, const gchar* name, gchar** users, int users_length1, GError** error);
	gchar* (*printer_add_option_default) (CupsPkHelper* self, const gchar* name, const gchar* option, gchar** values, int values_length1, GError** error);
	gchar* (*printer_delete_option_default) (CupsPkHelper* self, const gchar* name, const gchar* option, GError** error);
	gchar* (*printer_add_option) (CupsPkHelper* self, const gchar* name, const gchar* option, gchar** values, int values_length1, GError** error);
	gchar* (*job_cancel_purge) (CupsPkHelper* self, gint jobid, gboolean purge, GError** error);
	gchar* (*job_restart) (CupsPkHelper* self, gint jobid, GError** error);
	gchar* (*job_set_hold_until) (CupsPkHelper* self, gint jobid, const gchar* job_hold_until, GError** error);
};


static gpointer printers_job_parent_class = NULL;

GType printers_job_get_type (void) G_GNUC_CONST;
GType printers_printer_get_type (void) G_GNUC_CONST;
#define PRINTERS_JOB_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), PRINTERS_TYPE_JOB, PrintersJobPrivate))
PrintersJob* printers_job_new (cups_job_t* cjob, PrintersPrinter* printer);
PrintersJob* printers_job_construct (GType object_type, cups_job_t* cjob, PrintersPrinter* printer);
GType cups_notifier_get_type (void) G_GNUC_CONST;
CupsNotifier* cups_notifier_get_default (void);
static void ___lambda5_ (PrintersJob* self, const gchar* text, const gchar* printer_uri, const gchar* name, guint32 state, const gchar* state_reasons, gboolean is_accepting_jobs, guint32 job_id, guint32 job_state, const gchar* job_state_reason, const gchar* job_name, guint32 job_impressions_completed);
static void ____lambda5__cups_notifier_job_completed (CupsNotifier* _sender, const gchar* text, const gchar* printer_uri, const gchar* name, guint32 state, const gchar* state_reasons, gboolean is_accepting_jobs, guint32 job_id, guint32 job_state, const gchar* job_state_reason, const gchar* job_name, guint32 job_impressions_completed, gpointer self);
static void ___lambda6_ (PrintersJob* self, const gchar* text, const gchar* printer_uri, const gchar* name, guint32 state, const gchar* state_reasons, gboolean is_accepting_jobs, guint32 job_id, guint32 job_state, const gchar* job_state_reason, const gchar* job_name, guint32 job_impressions_completed);
static void ____lambda6__cups_notifier_job_stopped (CupsNotifier* _sender, const gchar* text, const gchar* printer_uri, const gchar* name, guint32 state, const gchar* state_reasons, gboolean is_accepting_jobs, guint32 job_id, guint32 job_state, const gchar* job_state_reason, const gchar* job_name, guint32 job_impressions_completed, gpointer self);
static void ___lambda7_ (PrintersJob* self, const gchar* text, const gchar* printer_uri, const gchar* name, guint32 state, const gchar* state_reasons, gboolean is_accepting_jobs, guint32 job_id, guint32 job_state, const gchar* job_state_reason, const gchar* job_name, guint32 job_impressions_completed);
static void ____lambda7__cups_notifier_job_state (CupsNotifier* _sender, const gchar* text, const gchar* printer_uri, const gchar* name, guint32 state, const gchar* state_reasons, gboolean is_accepting_jobs, guint32 job_id, guint32 job_state, const gchar* job_state_reason, const gchar* job_name, guint32 job_impressions_completed, gpointer self);
static void ___lambda8_ (PrintersJob* self, const gchar* text, const gchar* printer_uri, const gchar* name, guint32 state, const gchar* state_reasons, gboolean is_accepting_jobs, guint32 job_id, guint32 job_state, const gchar* job_state_reason, const gchar* job_name, guint32 job_impressions_completed);
static void ____lambda8__cups_notifier_job_state_changed (CupsNotifier* _sender, const gchar* text, const gchar* printer_uri, const gchar* name, guint32 state, const gchar* state_reasons, gboolean is_accepting_jobs, guint32 job_id, guint32 job_state, const gchar* job_state_reason, const gchar* job_name, guint32 job_impressions_completed, gpointer self);
void printers_job_pause (PrintersJob* self);
GType cups_pk_helper_proxy_get_type (void) G_GNUC_CONST;
guint cups_pk_helper_register_object (void* object, GDBusConnection* connection, const gchar* path, GError** error);
GType cups_pk_helper_get_type (void) G_GNUC_CONST;
CupsPkHelper* cups_get_pk_helper (void);
gchar* cups_pk_helper_job_set_hold_until (CupsPkHelper* self, gint jobid, const gchar* job_hold_until, GError** error);
void printers_job_stop (PrintersJob* self);
gchar* cups_pk_helper_job_cancel_purge (CupsPkHelper* self, gint jobid, gboolean purge, GError** error);
void printers_job_resume (PrintersJob* self);
GDateTime* printers_job_get_used_time (PrintersJob* self);
gchar* printers_job_translated_job_state (PrintersJob* self);
GIcon* printers_job_state_icon (PrintersJob* self);
GIcon* printers_job_get_file_icon (PrintersJob* self);
gchar* printers_job_get_hold_until (PrintersJob* self);
static void printers_job_finalize (GObject * obj);
static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func);


static void ___lambda5_ (PrintersJob* self, const gchar* text, const gchar* printer_uri, const gchar* name, guint32 state, const gchar* state_reasons, gboolean is_accepting_jobs, guint32 job_id, guint32 job_state, const gchar* job_state_reason, const gchar* job_name, guint32 job_impressions_completed) {
	guint32 _tmp0_;
	gint _tmp1_;
	g_return_if_fail (text != NULL);
	g_return_if_fail (printer_uri != NULL);
	g_return_if_fail (name != NULL);
	g_return_if_fail (state_reasons != NULL);
	g_return_if_fail (job_state_reason != NULL);
	g_return_if_fail (job_name != NULL);
	_tmp0_ = job_id;
	_tmp1_ = self->priv->uid;
	if (_tmp0_ == ((guint32) _tmp1_)) {
		g_signal_emit (self, printers_job_signals[PRINTERS_JOB_COMPLETED_SIGNAL], 0);
	}
}


static void ____lambda5__cups_notifier_job_completed (CupsNotifier* _sender, const gchar* text, const gchar* printer_uri, const gchar* name, guint32 state, const gchar* state_reasons, gboolean is_accepting_jobs, guint32 job_id, guint32 job_state, const gchar* job_state_reason, const gchar* job_name, guint32 job_impressions_completed, gpointer self) {
	___lambda5_ ((PrintersJob*) self, text, printer_uri, name, state, state_reasons, is_accepting_jobs, job_id, job_state, job_state_reason, job_name, job_impressions_completed);
}


static void ___lambda6_ (PrintersJob* self, const gchar* text, const gchar* printer_uri, const gchar* name, guint32 state, const gchar* state_reasons, gboolean is_accepting_jobs, guint32 job_id, guint32 job_state, const gchar* job_state_reason, const gchar* job_name, guint32 job_impressions_completed) {
	guint32 _tmp0_;
	gint _tmp1_;
	g_return_if_fail (text != NULL);
	g_return_if_fail (printer_uri != NULL);
	g_return_if_fail (name != NULL);
	g_return_if_fail (state_reasons != NULL);
	g_return_if_fail (job_state_reason != NULL);
	g_return_if_fail (job_name != NULL);
	_tmp0_ = job_id;
	_tmp1_ = self->priv->uid;
	if (_tmp0_ == ((guint32) _tmp1_)) {
		g_signal_emit (self, printers_job_signals[PRINTERS_JOB_STOPPED_SIGNAL], 0);
	}
}


static void ____lambda6__cups_notifier_job_stopped (CupsNotifier* _sender, const gchar* text, const gchar* printer_uri, const gchar* name, guint32 state, const gchar* state_reasons, gboolean is_accepting_jobs, guint32 job_id, guint32 job_state, const gchar* job_state_reason, const gchar* job_name, guint32 job_impressions_completed, gpointer self) {
	___lambda6_ ((PrintersJob*) self, text, printer_uri, name, state, state_reasons, is_accepting_jobs, job_id, job_state, job_state_reason, job_name, job_impressions_completed);
}


static void ___lambda7_ (PrintersJob* self, const gchar* text, const gchar* printer_uri, const gchar* name, guint32 state, const gchar* state_reasons, gboolean is_accepting_jobs, guint32 job_id, guint32 job_state, const gchar* job_state_reason, const gchar* job_name, guint32 job_impressions_completed) {
	guint32 _tmp0_;
	gint _tmp1_;
	g_return_if_fail (text != NULL);
	g_return_if_fail (printer_uri != NULL);
	g_return_if_fail (name != NULL);
	g_return_if_fail (state_reasons != NULL);
	g_return_if_fail (job_state_reason != NULL);
	g_return_if_fail (job_name != NULL);
	_tmp0_ = job_id;
	_tmp1_ = self->priv->uid;
	if (_tmp0_ == ((guint32) _tmp1_)) {
		g_signal_emit (self, printers_job_signals[PRINTERS_JOB_STATE_CHANGED_SIGNAL], 0);
	}
}


static void ____lambda7__cups_notifier_job_state (CupsNotifier* _sender, const gchar* text, const gchar* printer_uri, const gchar* name, guint32 state, const gchar* state_reasons, gboolean is_accepting_jobs, guint32 job_id, guint32 job_state, const gchar* job_state_reason, const gchar* job_name, guint32 job_impressions_completed, gpointer self) {
	___lambda7_ ((PrintersJob*) self, text, printer_uri, name, state, state_reasons, is_accepting_jobs, job_id, job_state, job_state_reason, job_name, job_impressions_completed);
}


static void ___lambda8_ (PrintersJob* self, const gchar* text, const gchar* printer_uri, const gchar* name, guint32 state, const gchar* state_reasons, gboolean is_accepting_jobs, guint32 job_id, guint32 job_state, const gchar* job_state_reason, const gchar* job_name, guint32 job_impressions_completed) {
	guint32 _tmp0_;
	gint _tmp1_;
	g_return_if_fail (text != NULL);
	g_return_if_fail (printer_uri != NULL);
	g_return_if_fail (name != NULL);
	g_return_if_fail (state_reasons != NULL);
	g_return_if_fail (job_state_reason != NULL);
	g_return_if_fail (job_name != NULL);
	_tmp0_ = job_id;
	_tmp1_ = self->priv->uid;
	if (_tmp0_ == ((guint32) _tmp1_)) {
		g_signal_emit (self, printers_job_signals[PRINTERS_JOB_STATE_CHANGED_SIGNAL], 0);
	}
}


static void ____lambda8__cups_notifier_job_state_changed (CupsNotifier* _sender, const gchar* text, const gchar* printer_uri, const gchar* name, guint32 state, const gchar* state_reasons, gboolean is_accepting_jobs, guint32 job_id, guint32 job_state, const gchar* job_state_reason, const gchar* job_name, guint32 job_impressions_completed, gpointer self) {
	___lambda8_ ((PrintersJob*) self, text, printer_uri, name, state, state_reasons, is_accepting_jobs, job_id, job_state, job_state_reason, job_name, job_impressions_completed);
}


PrintersJob* printers_job_construct (GType object_type, cups_job_t* cjob, PrintersPrinter* printer) {
	PrintersJob * self = NULL;
	cups_job_t _tmp0_;
	PrintersPrinter* _tmp1_;
	cups_job_t _tmp2_;
	gint _tmp3_;
	CupsNotifier* notifier = NULL;
	CupsNotifier* _tmp4_;
	gboolean _tmp5_ = FALSE;
	gboolean _tmp6_ = FALSE;
	cups_job_t _tmp7_;
	ipp_jstate_t _tmp8_;
	g_return_val_if_fail (cjob != NULL, NULL);
	g_return_val_if_fail (printer != NULL, NULL);
	self = (PrintersJob*) g_object_new (object_type, NULL);
	_tmp0_ = *cjob;
	self->cjob = _tmp0_;
	_tmp1_ = printer;
	self->priv->printer = _tmp1_;
	_tmp2_ = *cjob;
	_tmp3_ = _tmp2_.id;
	self->priv->uid = _tmp3_;
	_tmp4_ = cups_notifier_get_default ();
	notifier = _tmp4_;
	_tmp7_ = *cjob;
	_tmp8_ = _tmp7_.state;
	if (_tmp8_ != IPP_JOB_CANCELED) {
		cups_job_t _tmp9_;
		ipp_jstate_t _tmp10_;
		_tmp9_ = *cjob;
		_tmp10_ = _tmp9_.state;
		_tmp6_ = _tmp10_ != IPP_JOB_ABORTED;
	} else {
		_tmp6_ = FALSE;
	}
	if (_tmp6_) {
		cups_job_t _tmp11_;
		ipp_jstate_t _tmp12_;
		_tmp11_ = *cjob;
		_tmp12_ = _tmp11_.state;
		_tmp5_ = _tmp12_ != IPP_JOB_COMPLETED;
	} else {
		_tmp5_ = FALSE;
	}
	if (_tmp5_) {
		CupsNotifier* _tmp13_;
		CupsNotifier* _tmp14_;
		CupsNotifier* _tmp15_;
		CupsNotifier* _tmp16_;
		_tmp13_ = notifier;
		g_signal_connect_object (_tmp13_, "job-completed", (GCallback) ____lambda5__cups_notifier_job_completed, self, 0);
		_tmp14_ = notifier;
		g_signal_connect_object (_tmp14_, "job-stopped", (GCallback) ____lambda6__cups_notifier_job_stopped, self, 0);
		_tmp15_ = notifier;
		g_signal_connect_object (_tmp15_, "job-state", (GCallback) ____lambda7__cups_notifier_job_state, self, 0);
		_tmp16_ = notifier;
		g_signal_connect_object (_tmp16_, "job-state-changed", (GCallback) ____lambda8__cups_notifier_job_state_changed, self, 0);
	}
	return self;
}


PrintersJob* printers_job_new (cups_job_t* cjob, PrintersPrinter* printer) {
	return printers_job_construct (PRINTERS_TYPE_JOB, cjob, printer);
}


void printers_job_pause (PrintersJob* self) {
	GError * _inner_error_ = NULL;
	g_return_if_fail (self != NULL);
	{
		CupsPkHelper* _tmp0_;
		gint _tmp1_;
		gchar* _tmp2_;
		gchar* _tmp3_;
		_tmp0_ = cups_get_pk_helper ();
		_tmp1_ = self->priv->uid;
		_tmp2_ = cups_pk_helper_job_set_hold_until (_tmp0_, _tmp1_, "indefinite", &_inner_error_);
		_tmp3_ = _tmp2_;
		_g_free0 (_tmp3_);
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			goto __catch31_g_error;
		}
	}
	goto __finally31;
	__catch31_g_error:
	{
		GError* e = NULL;
		GError* _tmp4_;
		const gchar* _tmp5_;
		e = _inner_error_;
		_inner_error_ = NULL;
		_tmp4_ = e;
		_tmp5_ = _tmp4_->message;
		g_critical ("Job.vala:68: %s", _tmp5_);
		_g_error_free0 (e);
	}
	__finally31:
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
}


void printers_job_stop (PrintersJob* self) {
	GError * _inner_error_ = NULL;
	g_return_if_fail (self != NULL);
	{
		CupsPkHelper* _tmp0_;
		gint _tmp1_;
		gchar* _tmp2_;
		gchar* _tmp3_;
		_tmp0_ = cups_get_pk_helper ();
		_tmp1_ = self->priv->uid;
		_tmp2_ = cups_pk_helper_job_cancel_purge (_tmp0_, _tmp1_, FALSE, &_inner_error_);
		_tmp3_ = _tmp2_;
		_g_free0 (_tmp3_);
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			goto __catch32_g_error;
		}
	}
	goto __finally32;
	__catch32_g_error:
	{
		GError* e = NULL;
		GError* _tmp4_;
		const gchar* _tmp5_;
		e = _inner_error_;
		_inner_error_ = NULL;
		_tmp4_ = e;
		_tmp5_ = _tmp4_->message;
		g_critical ("Job.vala:76: %s", _tmp5_);
		_g_error_free0 (e);
	}
	__finally32:
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
}


void printers_job_resume (PrintersJob* self) {
	GError * _inner_error_ = NULL;
	g_return_if_fail (self != NULL);
	{
		CupsPkHelper* _tmp0_;
		gint _tmp1_;
		gchar* _tmp2_;
		gchar* _tmp3_;
		_tmp0_ = cups_get_pk_helper ();
		_tmp1_ = self->priv->uid;
		_tmp2_ = cups_pk_helper_job_set_hold_until (_tmp0_, _tmp1_, "no-hold", &_inner_error_);
		_tmp3_ = _tmp2_;
		_g_free0 (_tmp3_);
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			goto __catch33_g_error;
		}
	}
	goto __finally33;
	__catch33_g_error:
	{
		GError* e = NULL;
		GError* _tmp4_;
		const gchar* _tmp5_;
		e = _inner_error_;
		_inner_error_ = NULL;
		_tmp4_ = e;
		_tmp5_ = _tmp4_->message;
		g_critical ("Job.vala:84: %s", _tmp5_);
		_g_error_free0 (e);
	}
	__finally33:
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
}


GDateTime* printers_job_get_used_time (PrintersJob* self) {
	GDateTime* result = NULL;
	cups_job_t _tmp0_;
	time_t _tmp1_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->cjob;
	_tmp1_ = _tmp0_.completed_time;
	if (_tmp1_ != ((time_t) 0)) {
		cups_job_t _tmp2_;
		time_t _tmp3_;
		GDateTime* _tmp4_;
		_tmp2_ = self->cjob;
		_tmp3_ = _tmp2_.completed_time;
		_tmp4_ = g_date_time_new_from_unix_local ((gint64) _tmp3_);
		result = _tmp4_;
		return result;
	} else {
		cups_job_t _tmp5_;
		time_t _tmp6_;
		_tmp5_ = self->cjob;
		_tmp6_ = _tmp5_.processing_time;
		if (_tmp6_ != ((time_t) 0)) {
			cups_job_t _tmp7_;
			time_t _tmp8_;
			GDateTime* _tmp9_;
			_tmp7_ = self->cjob;
			_tmp8_ = _tmp7_.processing_time;
			_tmp9_ = g_date_time_new_from_unix_local ((gint64) _tmp8_);
			result = _tmp9_;
			return result;
		} else {
			cups_job_t _tmp10_;
			time_t _tmp11_;
			GDateTime* _tmp12_;
			_tmp10_ = self->cjob;
			_tmp11_ = _tmp10_.creation_time;
			_tmp12_ = g_date_time_new_from_unix_local ((gint64) _tmp11_);
			result = _tmp12_;
			return result;
		}
	}
}


gchar* printers_job_translated_job_state (PrintersJob* self) {
	gchar* result = NULL;
	cups_job_t _tmp0_;
	ipp_jstate_t _tmp1_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->cjob;
	_tmp1_ = _tmp0_.state;
	switch (_tmp1_) {
		case IPP_JOB_PENDING:
		{
			gchar* _tmp2_;
			_tmp2_ = g_strdup (_ ("Job Pending"));
			result = _tmp2_;
			return result;
		}
		case IPP_JOB_HELD:
		{
			gchar* _tmp3_;
			_tmp3_ = g_strdup (_ ("On Hold"));
			result = _tmp3_;
			return result;
		}
		case IPP_JOB_PROCESSING:
		{
			gchar* _tmp4_;
			_tmp4_ = g_strdup (_ ("Processing…"));
			result = _tmp4_;
			return result;
		}
		case IPP_JOB_STOPPED:
		{
			gchar* _tmp5_;
			_tmp5_ = g_strdup (_ ("Job Stopped"));
			result = _tmp5_;
			return result;
		}
		case IPP_JOB_CANCELED:
		{
			gchar* _tmp6_;
			_tmp6_ = g_strdup (_ ("Job Canceled"));
			result = _tmp6_;
			return result;
		}
		case IPP_JOB_ABORTED:
		{
			gchar* _tmp7_;
			_tmp7_ = g_strdup (_ ("Job Aborted"));
			result = _tmp7_;
			return result;
		}
		default:
		case IPP_JOB_COMPLETED:
		{
			gchar* _tmp8_;
			_tmp8_ = g_strdup (_ ("Job Completed"));
			result = _tmp8_;
			return result;
		}
	}
}


GIcon* printers_job_state_icon (PrintersJob* self) {
	GIcon* result = NULL;
	cups_job_t _tmp0_;
	ipp_jstate_t _tmp1_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->cjob;
	_tmp1_ = _tmp0_.state;
	switch (_tmp1_) {
		case IPP_JOB_PENDING:
		case IPP_JOB_PROCESSING:
		{
			result = NULL;
			return result;
		}
		case IPP_JOB_HELD:
		case IPP_JOB_STOPPED:
		{
			GThemedIcon* _tmp2_;
			_tmp2_ = (GThemedIcon*) g_themed_icon_new ("media-playback-pause");
			result = (GIcon*) _tmp2_;
			return result;
		}
		case IPP_JOB_CANCELED:
		case IPP_JOB_ABORTED:
		{
			GThemedIcon* _tmp3_;
			_tmp3_ = (GThemedIcon*) g_themed_icon_new ("process-error-symbolic");
			result = (GIcon*) _tmp3_;
			return result;
		}
		default:
		case IPP_JOB_COMPLETED:
		{
			GThemedIcon* _tmp4_;
			_tmp4_ = (GThemedIcon*) g_themed_icon_new ("process-completed-symbolic");
			result = (GIcon*) _tmp4_;
			return result;
		}
	}
}


static gboolean string_contains (const gchar* self, const gchar* needle) {
	gboolean result = FALSE;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (needle != NULL, FALSE);
	_tmp0_ = needle;
	_tmp1_ = strstr ((gchar*) self, (gchar*) _tmp0_);
	result = _tmp1_ != NULL;
	return result;
}


static gchar* string_replace (const gchar* self, const gchar* old, const gchar* replacement) {
	gchar* result = NULL;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (old != NULL, NULL);
	g_return_val_if_fail (replacement != NULL, NULL);
	if ((*((gchar*) self)) == '\0') {
		_tmp1_ = TRUE;
	} else {
		const gchar* _tmp2_;
		_tmp2_ = old;
		_tmp1_ = (*((gchar*) _tmp2_)) == '\0';
	}
	if (_tmp1_) {
		_tmp0_ = TRUE;
	} else {
		const gchar* _tmp3_;
		const gchar* _tmp4_;
		_tmp3_ = old;
		_tmp4_ = replacement;
		_tmp0_ = g_strcmp0 (_tmp3_, _tmp4_) == 0;
	}
	if (_tmp0_) {
		gchar* _tmp5_;
		_tmp5_ = g_strdup (self);
		result = _tmp5_;
		return result;
	}
	{
		GRegex* regex = NULL;
		const gchar* _tmp6_;
		gchar* _tmp7_;
		gchar* _tmp8_;
		GRegex* _tmp9_;
		GRegex* _tmp10_;
		gchar* _tmp11_ = NULL;
		GRegex* _tmp12_;
		const gchar* _tmp13_;
		gchar* _tmp14_;
		gchar* _tmp15_;
		_tmp6_ = old;
		_tmp7_ = g_regex_escape_string (_tmp6_, -1);
		_tmp8_ = _tmp7_;
		_tmp9_ = g_regex_new (_tmp8_, 0, 0, &_inner_error_);
		_tmp10_ = _tmp9_;
		_g_free0 (_tmp8_);
		regex = _tmp10_;
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			if (_inner_error_->domain == G_REGEX_ERROR) {
				goto __catch34_g_regex_error;
			}
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
		_tmp12_ = regex;
		_tmp13_ = replacement;
		_tmp14_ = g_regex_replace_literal (_tmp12_, self, (gssize) -1, 0, _tmp13_, 0, &_inner_error_);
		_tmp11_ = _tmp14_;
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			_g_regex_unref0 (regex);
			if (_inner_error_->domain == G_REGEX_ERROR) {
				goto __catch34_g_regex_error;
			}
			_g_regex_unref0 (regex);
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
		_tmp15_ = _tmp11_;
		_tmp11_ = NULL;
		result = _tmp15_;
		_g_free0 (_tmp11_);
		_g_regex_unref0 (regex);
		return result;
	}
	goto __finally34;
	__catch34_g_regex_error:
	{
		GError* e = NULL;
		e = _inner_error_;
		_inner_error_ = NULL;
		g_assert_not_reached ();
		_g_error_free0 (e);
	}
	__finally34:
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return NULL;
	}
}


GIcon* printers_job_get_file_icon (PrintersJob* self) {
	GIcon* result = NULL;
	gchar* title = NULL;
	cups_job_t _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	gboolean _tmp3_ = FALSE;
	gboolean _tmp4_ = FALSE;
	gboolean _tmp5_ = FALSE;
	const gchar* _tmp6_;
	gboolean _tmp7_;
	cups_job_t _tmp24_;
	const gchar* _tmp25_;
	gchar* _tmp26_;
	gchar* _tmp27_;
	GThemedIcon* _tmp28_;
	GIcon* _tmp29_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->cjob;
	_tmp1_ = _tmp0_.title;
	_tmp2_ = g_utf8_strdown (_tmp1_, (gssize) -1);
	title = _tmp2_;
	_tmp6_ = title;
	_tmp7_ = string_contains (_tmp6_, ".png");
	if (_tmp7_) {
		_tmp5_ = TRUE;
	} else {
		const gchar* _tmp8_;
		gboolean _tmp9_;
		_tmp8_ = title;
		_tmp9_ = string_contains (_tmp8_, ".jpg");
		_tmp5_ = _tmp9_;
	}
	if (_tmp5_) {
		_tmp4_ = TRUE;
	} else {
		const gchar* _tmp10_;
		gboolean _tmp11_;
		_tmp10_ = title;
		_tmp11_ = string_contains (_tmp10_, ".jpeg");
		_tmp4_ = _tmp11_;
	}
	if (_tmp4_) {
		_tmp3_ = TRUE;
	} else {
		const gchar* _tmp12_;
		gboolean _tmp13_;
		_tmp12_ = title;
		_tmp13_ = string_contains (_tmp12_, ".bmp");
		_tmp3_ = _tmp13_;
	}
	if (_tmp3_) {
		GThemedIcon* _tmp14_;
		_tmp14_ = (GThemedIcon*) g_themed_icon_new ("image-x-generic");
		result = (GIcon*) _tmp14_;
		_g_free0 (title);
		return result;
	} else {
		const gchar* _tmp15_;
		gboolean _tmp16_;
		_tmp15_ = title;
		_tmp16_ = string_contains (_tmp15_, ".xcf");
		if (_tmp16_) {
			GThemedIcon* _tmp17_;
			_tmp17_ = (GThemedIcon*) g_themed_icon_new ("image-x-xcf");
			result = (GIcon*) _tmp17_;
			_g_free0 (title);
			return result;
		} else {
			const gchar* _tmp18_;
			gboolean _tmp19_;
			_tmp18_ = title;
			_tmp19_ = string_contains (_tmp18_, ".svg");
			if (_tmp19_) {
				GThemedIcon* _tmp20_;
				_tmp20_ = (GThemedIcon*) g_themed_icon_new ("image-x-svg+xml");
				result = (GIcon*) _tmp20_;
				_g_free0 (title);
				return result;
			} else {
				const gchar* _tmp21_;
				gboolean _tmp22_;
				_tmp21_ = title;
				_tmp22_ = string_contains (_tmp21_, ".pdf");
				if (_tmp22_) {
					GThemedIcon* _tmp23_;
					_tmp23_ = (GThemedIcon*) g_themed_icon_new ("application-pdf");
					result = (GIcon*) _tmp23_;
					_g_free0 (title);
					return result;
				}
			}
		}
	}
	_tmp24_ = self->cjob;
	_tmp25_ = _tmp24_.format;
	_tmp26_ = string_replace (_tmp25_, "/", "-");
	_tmp27_ = _tmp26_;
	_tmp28_ = (GThemedIcon*) g_themed_icon_new (_tmp27_);
	_tmp29_ = (GIcon*) _tmp28_;
	_g_free0 (_tmp27_);
	result = _tmp29_;
	_g_free0 (title);
	return result;
}


gchar* printers_job_get_hold_until (PrintersJob* self) {
	gchar* result = NULL;
	gchar* job_uri = NULL;
	gchar* _tmp0_;
	gint job_uri_length1;
	gint _job_uri_size_;
	gchar* _tmp1_;
	gint _tmp1__length1;
	gint _tmp2_;
	ipp_t* request = NULL;
	ipp_t* _tmp3_;
	ipp_t* _tmp4_;
	gchar* _tmp5_;
	gint _tmp5__length1;
	gchar** attributes = NULL;
	gchar* _tmp6_;
	gchar** _tmp7_;
	gint attributes_length1;
	gint _attributes_size_;
	ipp_t* _tmp8_;
	gchar** _tmp9_;
	gint _tmp9__length1;
	http_t* _tmp10_;
	ipp_t* _tmp11_;
	ipp_status_t _tmp12_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = g_new0 (gchar, HTTP_MAX_URI);
	job_uri = _tmp0_;
	job_uri_length1 = HTTP_MAX_URI;
	_job_uri_size_ = job_uri_length1;
	_tmp1_ = job_uri;
	_tmp1__length1 = job_uri_length1;
	_tmp2_ = self->priv->uid;
	httpAssembleURIf (HTTP_URI_CODING_QUERY, _tmp1_, _tmp1__length1, "ipp", NULL, "localhost", 0, "/jobs/%d", _tmp2_);
	_tmp3_ = ippNewRequest (IPP_GET_JOB_ATTRIBUTES);
	request = _tmp3_;
	_tmp4_ = request;
	_tmp5_ = job_uri;
	_tmp5__length1 = job_uri_length1;
	ippAddString (_tmp4_, IPP_TAG_OPERATION, IPP_TAG_URI, "job-uri", NULL, (const gchar*) _tmp5_);
	_tmp6_ = g_strdup ("job-hold-until");
	_tmp7_ = g_new0 (gchar*, 1 + 1);
	_tmp7_[0] = _tmp6_;
	attributes = _tmp7_;
	attributes_length1 = 1;
	_attributes_size_ = attributes_length1;
	_tmp8_ = request;
	_tmp9_ = attributes;
	_tmp9__length1 = attributes_length1;
	ippAddStrings (_tmp8_, IPP_TAG_OPERATION, IPP_TAG_KEYWORD, "requested-attributes", _tmp9__length1, NULL, _tmp9_);
	_tmp10_ = CUPS_HTTP_DEFAULT;
	request = cupsDoRequest (_tmp10_, request, "/");
	_tmp11_ = request;
	_tmp12_ = ippGetStatusCode (_tmp11_);
	if (_tmp12_ <= IPP_OK_CONFLICT) {
		ipp_attribute_t* attr = NULL;
		ipp_t* _tmp13_;
		ipp_attribute_t* _tmp14_;
		ipp_attribute_t* _tmp15_;
		const gchar* _tmp16_;
		gchar* _tmp17_;
		_tmp13_ = request;
		_tmp14_ = ippFindAttribute (_tmp13_, "job-hold-until", IPP_TAG_ZERO);
		attr = _tmp14_;
		_tmp15_ = attr;
		_tmp16_ = ippGetString (_tmp15_, 0, NULL);
		_tmp17_ = g_strdup (_tmp16_);
		result = _tmp17_;
		attributes = (_vala_array_free (attributes, attributes_length1, (GDestroyNotify) g_free), NULL);
		_ippDelete0 (request);
		job_uri = (g_free (job_uri), NULL);
		return result;
	} else {
		ipp_t* _tmp18_;
		ipp_status_t _tmp19_;
		const gchar* _tmp20_;
		gchar* _tmp21_;
		_tmp18_ = request;
		_tmp19_ = ippGetStatusCode (_tmp18_);
		_tmp20_ = ippErrorString (_tmp19_);
		g_critical ("Job.vala:165: Error: %s", _tmp20_);
		_tmp21_ = g_strdup ("no-hold");
		result = _tmp21_;
		attributes = (_vala_array_free (attributes, attributes_length1, (GDestroyNotify) g_free), NULL);
		_ippDelete0 (request);
		job_uri = (g_free (job_uri), NULL);
		return result;
	}
	attributes = (_vala_array_free (attributes, attributes_length1, (GDestroyNotify) g_free), NULL);
	_ippDelete0 (request);
	job_uri = (g_free (job_uri), NULL);
}


static void printers_job_class_init (PrintersJobClass * klass) {
	printers_job_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (PrintersJobPrivate));
	G_OBJECT_CLASS (klass)->finalize = printers_job_finalize;
	printers_job_signals[PRINTERS_JOB_STOPPED_SIGNAL] = g_signal_new ("stopped", PRINTERS_TYPE_JOB, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
	printers_job_signals[PRINTERS_JOB_COMPLETED_SIGNAL] = g_signal_new ("completed", PRINTERS_TYPE_JOB, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
	printers_job_signals[PRINTERS_JOB_STATE_CHANGED_SIGNAL] = g_signal_new ("state-changed", PRINTERS_TYPE_JOB, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
}


static void printers_job_instance_init (PrintersJob * self) {
	self->priv = PRINTERS_JOB_GET_PRIVATE (self);
}


static void printers_job_finalize (GObject * obj) {
	PrintersJob * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, PRINTERS_TYPE_JOB, PrintersJob);
	G_OBJECT_CLASS (printers_job_parent_class)->finalize (obj);
}


GType printers_job_get_type (void) {
	static volatile gsize printers_job_type_id__volatile = 0;
	if (g_once_init_enter (&printers_job_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (PrintersJobClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) printers_job_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PrintersJob), 0, (GInstanceInitFunc) printers_job_instance_init, NULL };
		GType printers_job_type_id;
		printers_job_type_id = g_type_register_static (G_TYPE_OBJECT, "PrintersJob", &g_define_type_info, 0);
		g_once_init_leave (&printers_job_type_id__volatile, printers_job_type_id);
	}
	return printers_job_type_id__volatile;
}


static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}



